<template>
  <v-container>
    <v-breadcrumbs class="px-0" :items="items"></v-breadcrumbs>

    <v-row no-gutters class="d-flex align-center">
      <h1>Novo Fornecedor</h1>
      <v-spacer></v-spacer>
      <v-btn depressed small color="warning" to="/providers/">VOLTAR</v-btn>
    </v-row>
    <v-divider></v-divider>
    <div id="providers">
      <h2>Preencha o formulário:</h2>

      <v-form v-model="valid">
        <v-container>
          <v-row>
            <v-col cols="12" md="6">
              <v-text-field
                v-model="provider.name"
                :rules="nameRules"
                label="Nome completo"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="provider.phone" :rules="phoneRules" label="Telefone" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="provider.email" :rules="emailRules" label="E-mail" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="provider.cnpj" :rules="cnpjRules" label="CNPJ" required></v-text-field>
            </v-col>

            <v-col cols="12" md="12">
              <v-text-field v-model="provider.service" label="Tipo de serviço ofertado" required></v-text-field>
            </v-col>

            <v-col cols="12" md="2">
              <v-text-field v-model="provider.cep" label="CEP" required></v-text-field>
            </v-col>

            <v-col cols="12" md="4">
              <v-text-field v-model="provider.street" label="Rua" required></v-text-field>
            </v-col>

            <v-col cols="12" md="2">
              <v-text-field v-model="provider.number" label="Número" required></v-text-field>
            </v-col>

            <v-col cols="12" md="4">
              <v-text-field v-model="provider.neighborhood" label="Bairro" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="provider.city" label="Cidade" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="provider.state" label="Estado" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6"></v-col>
          </v-row>
          <v-btn depressed color="success" @click="salvar">SALVAR</v-btn>
        </v-container>
      </v-form>
      <v-row>
        <v-spacer></v-spacer>
      </v-row>
    </div>
  </v-container>
</template>

<script>
import axios from "axios";
export default {
  data: () => ({
    valid: false,
    provider: {
      name: "",
      phone: "",
      cnpj: "",
      email: "",
      street: "",
      service: "",
      cep: "",
      number: "",
      city: "",
      state: "",
      neighborhood: ""
    },
    edit: false,
    cnpjRules: [v => !!v || "CNPJ é obrigatório"],
    nameRules: [v => !!v || "Nome é obrigatório"],
    emailRules: [
      v => !!v || "E-mail é obrigatório",
      v => /.+@.+/.test(v) || "E-mail inválido"
    ],
    phoneRules: [],
    items: [
      {
        text: "Dashboard",
        disabled: false,
        to: "/"
      },
      {
        text: "Fornecedores",
        disabled: false,
        exact: true,
        to: "/providers"
      },
      {
        text: "Cadastrar fornecedor",
        disabled: true
      }
    ]
  }),
  methods: {
    salvar() {
      if (this.edit == false) {
        console.log("salvar");
        console.log(this.provider);
        axios
          .post("https://young-forest-65938.herokuapp.com/api/v1/providers", {
            name: this.provider.name,
            phone: this.provider.phone,
            service: this.provider.service,
            email: this.provider.email,
            cnpj: this.provider.cnpj,
            street: this.provider.street,
            cep: this.provider.cep,
            number: this.provider.number,
            city: this.provider.city,
            state: this.provider.state,
            neighborhood: this.provider.neighborhood
          })
          .then(function(response) {
            console.log(this.provider);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/providers");
      } else {
        console.log("editar else");
        axios
          .put(
            `https://young-forest-65938.herokuapp.com/api/v1/providers/${this.$router.currentRoute.query.id}`,
            {
              name: this.provider.name,
              phone: this.provider.phone,
              service: this.provider.service,
              email: this.provider.email,
              cnpj: this.provider.cnpj,
              street: this.provider.street,
              cep: this.provider.cep,
              number: this.provider.number,
              city: this.provider.city,
              state: this.provider.state,
              neighborhood: this.provider.neighborhood
            }
          )
          .then(function(response) {
            console.log(this.provider);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/providers");
      }
    }
  }
};
</script>